<template>
  <div class="flex flex-col pb-7 h-full">
    <OfferBadge
      v-if="isOfferApplied"
      text="SAMPLE PACK DISCOUNT APPLIED ($2/DOSE)"
    />
    <OfferBadge
      v-if="currentStageIndex === 8"
      text="FREE 2-DAY SHIPPING"
    />
    <ReferOutModal
      v-if="refer"
    />
    <common-navbar
      :current-status-number="currentStatusNumber"
    >
      <CommonLogo v-if="currentQuiz.displayLogo"/>
      <img
        v-else-if="currentQuiz.displayBackBtn"
        src="@/assets/img/icons/back-button.png"
        class="w-5 cursor-pointer"
        alt="back-btn"
      >
      <div v-else></div>
      <div
        class="text-center text-base font-bold"
        v-if="currentQuiz.title"
      >
        {{ currentQuiz.title }}
      </div>
      <div
        class="border border-red flex rounded-md py-2 px-5 text-sm font-bold cursor-pointer"
        @click="isHelpDisplayed = true"
      >
        Help?
      </div>
    </common-navbar>
    <main class="relative flex-auto mt-8 flex flex-col px-5 sm:px-0 max-w-quiz w-full mx-auto">
      <transition name="fast-fade">
        <div class="rounded bg-black absolute top-0 p-5 flex flex-col z-20" v-if="isHelpDisplayed">
          <div class="text-xl font-bold text-white pr-8 mb-3">
            Not sure which product is right for you?
          </div>
          <div class="text-base text-white">Call us at (877) 907-4047 to speak with one of our friendly consultants.</div>
          <div
            class="cursor-pointer absolute right-5 top-5 flex items-center justify-center w-4 h-4"
            @click="isHelpDisplayed = false"
          >
            <CloseIcon bg-color="bg-white"/>
          </div>
        </div>
      </transition>
      <Component
        :is="currentQuiz.component"
        @nextStage="nextStage"
      />
    </main>
  </div>
</template>

<script>
import CommonNavbar from "@/components/common/CommonNavbar";
import GetStarted from "@/components/quizes/GetStarted";
import GetStartedFooter from "@/components/quizes/GetStartedFooter";
import Interstitial from "@/components/quizes/Interstitial";
import WhatResults from "@/components/quizes/WhatResults";
import TheBasics from "@/components/quizes/TheBasics/TheBasics";
import CommonLogo from "@/components/common/CommonLogo";
import OfferModal from "@/components/modals/OfferModal";
import OfferBadge from "@/components/misc/OfferBadge";
import YourHealth from "@/components/quizes/YourHealth/YourHealth";
import {answersMixin, referMixin} from "@/utils/mixins";
import CloseIcon from "@/components/icons/CloseIcon";
import TreatmentPreference from "@/components/quizes/TreatmentPreference/TreatmentPreference";
import VisitSummary from "@/components/quizes/VisitSummary/VisitSummary";
import Checkout from "@/components/quizes/Checkout";
import Confirmation from "@/components/quizes/Confirmation";
import ReferOutModal from "@/components/quizes/ReferOutModal";

export default {
  mixins: [answersMixin, referMixin],
  name: "PageQuiz",
  components: {
    ReferOutModal,
    CloseIcon,
    OfferBadge,
    OfferModal, CommonLogo, TheBasics, WhatResults, Interstitial, GetStartedFooter, GetStarted, CommonNavbar
  },
  data() {
    return {
      quizStages: {
        1: {
          component: GetStarted,
          displayLogo: true
        },
        2: {
          component: Interstitial,
          displayLogo: true
        },
        3: {
          component: WhatResults,
          displayBackBtn: true
        },
        4: {
          component: TheBasics,
          displayBackBtn: true,
          title: 'The Basics'
        },
        5: {
          component: YourHealth,
          displayBackBtn: true,
          title: 'Your Health',
        },
        6: {
          component: TreatmentPreference,
          displayBackBtn: true,
          title: 'Treatment Preference'
        },
        7: {
          component: VisitSummary,
          displayBackBtn: true,
          title: 'Visit Summary'
        },
        8: {
          component: Checkout,
          displayBackBtn: true,
          title: 'Checkout'
        },
        9: {
          component: Confirmation,
          title: 'Confirmation'
        },
      },
      isHelpDisplayed: false,
      currentStageIndex: 1,
    }
  },
  computed: {
    currentQuiz() {
      return this.quizStages[this.currentStageIndex]
    },
    isOfferApplied() {
      return this.answer(this.answersKeys.OFFER_MODAL)?.default
    },
    currentStatusNumber() {
      let number = null

      switch (this.currentStageIndex) {
        case 4:
          number = 1
          break;
        case 5:
          number = 2
          break;
        default:
          number = null
      }

      return number
    },
  },
  methods: {
    nextStage() {
      this.currentStageIndex++
    },
  }
}
</script>

<style scoped>

</style>
